<?php
/*
Plugin Name: Wordpress Mega Pack for News, Blog and Magazine - All you need
Author: Ad-theme.com
*/

function wpmegapack_vc_add_image_sizes() {

	add_image_size( 'wpmegaposts-normal', 800 , 800 , true);
	add_image_size( 'wpmegaposts-header', 800 , 600 , true);

}

add_action('after_setup_theme', 'wpmegapack_vc_add_image_sizes');

/**************************************************************************/
/************************ FUNCTION POST INFO ******************************/
/**************************************************************************/

function wpmegapack_vc_thumbs() {
	global $post;
	if(has_post_thumbnail()){ 
			$id_post = get_the_id();					
			$single_image = wp_get_attachment_image_src( get_post_thumbnail_id($id_post), 'wpmegaposts-normal' );	 					 
		} else {               
             $single_image[0] = WPMP_VC_URL .'assets/img/no-img.jpg';                 
    }	
	$return =	'<img class="megaposts-thumbs" src="'.$single_image[0].'" alt="'.get_the_title().'">';
	return $return;
}

// URL

function wpmegapack_vc_thumbs_url($id_post) {
	global $post;
	if(has_post_thumbnail()){  
			$id_post = get_the_id();					
			$single_image = wp_get_attachment_image_src( get_post_thumbnail_id($id_post), 'wpmegaposts-header' );	 					 
		} else {               
             $single_image[0] = WPMP_VC_URL .'assets/img/no-img.jpg';                
    }	
	$return = $single_image[0];
	return $return;
}



/************************************************************/
/*********************** GET CATEGORIES *********************/
/************************************************************/

function wpmegapack_vc_category($source,$posts_type) {
	$separator = ' ';
	$output = '';	
	if($source=='post') {
		$categories = get_the_category();
		if($categories){
			foreach($categories as $category) {
				$output .= '<a href="'.get_category_link( $category->term_id ).'" title="' . esc_attr( sprintf( __( "View all posts in %s",'wpmegapack_vc' ), $category->name ) ) . '">'.$category->cat_name.'</a>'.$separator;
			}
		}
	} elseif($source=='post_type') {
		global $post;
		$taxonomy_names = get_object_taxonomies( $posts_type );
		$term_list = wp_get_post_terms($post->ID,$taxonomy_names);
		if($term_list){
			foreach ($term_list as $tax_term) {
				$output .= '<a href="' . esc_attr(get_term_link($tax_term, $posts_type)) . '" title="' . sprintf( __( "View all posts in %s" ), $tax_term->name ) . '" ' . '>' . $tax_term->name.'</a>'.$separator;
			}
		}
	}
	$return = trim($output, $separator);
	return $return;
}


/**************************************************************************/
/************************** FUNCTION SHARE ********************************/
/**************************************************************************/


function wpmegapack_vc_share() {
	global $post;
	$pinterestimage = wp_get_attachment_image_src( get_post_thumbnail_id( $post->ID ), 'full' );
	
		
	$return = '<div class="share">
					<div class="icon">						
						<a target="_blank" class="icon-pinterest" href="http://pinterest.com/pin/create/button/?url='.urlencode(get_permalink($post->ID)).'&media='.$pinterestimage[0].'&description='.get_the_title().'" title="'.__('Click to share this post on Pinterest','wpmegapack_vc').'"></a>
						<a target="_blank" class="icon-google-plus" href="https://plus.google.com/share?url='.get_the_permalink().'" title="'.__('Click to share this post on Google+','wpmegapack_vc').'"></a>
						<a target="_blank" class="icon-twitter" href="http://twitter.com/home?status='.get_the_permalink().'" title="'.__('Click to share this post on Twitter','wpmegapack_vc').'"></a>
						<a target="_blank" class="icon-facebook" href="http://www.facebook.com/sharer.php?u='.get_the_permalink().'&amp;t='.get_the_title().'" title="'.__('Click to share this post on Facebook','wpmegapack_vc').'"></a>
    					<a href="#" class="share-icon icon-rocket"></a>
					</div>
				</div>';
	
    return $return;
    
}


function wpmegapack_vc_share_left() {
	global $post;
	$pinterestimage = wp_get_attachment_image_src( get_post_thumbnail_id( $post->ID ), 'full' );
	
		
	$return = '<div class="share">
					<div class="icon">
						<a href="#" class="share-icon icon-rocket"></a>						
						<a target="_blank" class="icon-pinterest" href="http://pinterest.com/pin/create/button/?url='.urlencode(get_permalink($post->ID)).'&media='.$pinterestimage[0].'&description='.get_the_title().'" title="'.__('Click to share this post on Pinterest','wpmegapack_vc').'"></a>
						<a target="_blank" class="icon-google-plus" href="https://plus.google.com/share?url='.get_the_permalink().'" title="'.__('Click to share this post on Google+','wpmegapack_vc').'"></a>
						<a target="_blank" class="icon-twitter" href="http://twitter.com/home?status='.get_the_permalink().'" title="'.__('Click to share this post on Twitter','wpmegapack_vc').'"></a>
						<a target="_blank" class="icon-facebook" href="http://www.facebook.com/sharer.php?u='.get_the_permalink().'&amp;t='.get_the_title().'" title="'.__('Click to share this post on Facebook','wpmegapack_vc').'"></a>
					</div>
				</div>';
	
    return $return;
    
}



/**************************************************************************/
/************************** FUNCTION EXCERPT ******************************/
/**************************************************************************/

function wpmegapack_vc_excerpt($excerpt,$separator) {
	$return = substr(get_the_excerpt(), 0, $excerpt);
	$return .= $separator;
	return $return;
}

/**************************************************************************/
/************************** FUNCTION VIEW *********************************/
/**************************************************************************/

function wpmegapack_vc_get_post_views($postID){
    $count_key = 'wpb_post_views_count';
    $count = get_post_meta($postID, $count_key, true);
    if($count==''){
        delete_post_meta($postID, $count_key);
        add_post_meta($postID, $count_key, '0');
		$view = __('Views','wpmegapack_vc');
        return "0";
    }
	$count_final = $count; 
    return $count_final;
}

function wpmegapack_vc_set_post_views() {
	if ( is_single() ) {
	global $post;
	$postID = $post->ID;	
    $count_key = 'wpb_post_views_count';
    $count = get_post_meta($postID, $count_key, true);
    if($count==''){
        $count = 0;
        delete_post_meta($postID, $count_key);
        add_post_meta($postID, $count_key, '0');
    }else{
        $count++;
        update_post_meta($postID, $count_key, $count);
    }
	}
}
add_filter( 'wp_footer', 'wpmegapack_vc_set_post_views', 200000 );



/************************************************************/
/*********************** GET POST TYPE **********************/
/************************************************************/
function wpmp_vc_all_post_types() {

	// Select all public post types
	$args = array(
	   'public'   => true,
	);
	
	$all_types = get_post_types($args, 'names', 'and');
	
	
	// Put them in an ordered array filtering the types you don't want
	
	$sel_types = array();
	
	foreach ($all_types as $type) {
	
		if ($type != 'attachment' && $type != 'post' && $type != 'page') { 
			$sel_types[] = $type; 
		}
		
	}
	
	
	// Return Selected Post Types Array
	$return = '';
	$return .= '<select id="admegaposts_post_type">';
	foreach ($sel_types as $slug) {
		$return .= '<option value="'.$slug.'">'.$slug.'</option>';	
	}
	$return .= '</select>';
	
	
	return $return;

}

/************************************************************/
/******************** GET POST TYPE WIDGET ******************/
/************************************************************/
function wpmp_vc_all_post_types_for_widget($id_select,$name_select,$source) {

	// Select all public post types
	$args = array(
	   'public'   => true,
	);
	
	$all_types = get_post_types($args, 'names', 'and');
	
	
	// Put them in an ordered array filtering the types you don't want
	
	$sel_types = array();
	
	foreach ($all_types as $type) {
	
		if ($type != 'attachment' && $type != 'page') { 
			$sel_types[] = $type; 
		}
		
	}
	
	
	// Return Selected Post Types Array
	$return = '';
	$return .= '<select id="'.$id_select.'" name="'.$name_select.'" class="widefat">';
	foreach ($sel_types as $slug) {
		if($source == $slug) { $selected = 'selected="selected"'; } else { $selected = ''; }
		$return .= '<option '.$selected.' value="'.$slug.'">'.$slug.'</option>';	
	}
	$return .= '</select>';
	
	
	return $return;

}

/************************************************************/
/*********************** GET TAXONOMY ***********************/
/************************************************************/  
function wpmp_vc_all_taxonomy_for_widget($id_select,$name_select,$source) { 
	$args = array(
	  'public'   => true,
	  '_builtin' => false  
	); 
	$output = 'names'; 
	$operator = 'and';
	$taxonomies = get_taxonomies( $args, $output, $operator ); 
	$return = '';
	$return .= '<select id="'.$id_select.'" name="'.$name_select.'" class="widefat">';
	if($source == 'category') { $selected = 'selected="selected"'; } else { $selected = ''; }
	$return .= '<option '.$selected.' value="category">Category</option>';	
	if ( $taxonomies ) {
	  foreach ( $taxonomies  as $taxonomy ) {
		if($source == $taxonomy) { $selected = 'selected="selected"'; } else { $selected = ''; }		  
		$return .= '<option '.$selected.' value="'.$taxonomy.'">' . $taxonomy . '</option>';
	  }
	}
	$return .= '</select>';
	return $return;	
}




/************************************************************/
/************************ WP QUERY **************************/
/************************************************************/

function wpmegapack_vc_query($source,
						  $posts_source, 
						  $post_type, 
						  $categories,
						  $categories_post_type,
						  $order, 
						  $orderby, 
						  $pagination, 
						  $pagination_type,
						  $num_posts, 
						  $num_posts_page) {
							  
					if($orderby == 'views') { 
							$orderby = 'meta_value_num'; 
							$view_order = 'views';
					} else { $view_order = ''; }	
									
					if($source == 'wp_custom_posts_type') {
						$posts_source = 'all_posts';
					}
					
					if($posts_source == 'all_posts') {
					
						$query = 'post_type=Post&post_status=publish&orderby='.$orderby.'&order='.$order.'';						
						
						// CUSTOM POST TYPE
						if($source == 'posts_type') {
							$query .= '&post_type='.$post_type.'';
						}

						if($view_order == 'views') { 
							$query .= '&meta_key=wpb_post_views_count';
						}
						
						// CATEGORIES POST TYPE
						if($categories_post_type != '' && !empty($categories_post_type) && $source == 'posts_type') {
							$taxonomy_names = get_object_taxonomies( $post_type );
							$query .= '&'.$taxonomy_names[0].'='.$categories_post_type.'';	
						}

						// CATEGORIES POSTS
						if($categories != '' && $categories != 'all' && !empty($categories) && $source == 'post') {
							$query .= '&category_name='.$categories.'';	
						}
							
						if($pagination == 'yes') {
							$query .= '&posts_per_page='.$num_posts_page.'';	
						} else {
							if($num_posts == '') { $num_posts = '-1'; }
							$query .= '&posts_per_page='.$num_posts.'';
						}
					
						// PAGINATION		
						if($pagination == 'yes') {
							if ( get_query_var('paged') ) {
								$paged = get_query_var('paged');
							
							} elseif ( get_query_var('page') ) {			
								$paged = get_query_var('page');			
							} else {			
								$paged = 1;			
							}			
							$query .= '&paged='.$paged.'';
						}
						// #PAGINATION	
					
					} else { // IF STICKY
						

						if($pagination == 'yes') {
							$num_posts = $num_posts_page;	
						} else {
							if($num_posts == '') { $num_posts = '-1'; }
							$num_posts = $num_posts;
						}

						// PAGINATION		
						
						if ( get_query_var('paged') ) {
							$paged = get_query_var('paged');							
						} elseif ( get_query_var('page') ) {			
							$paged = get_query_var('page');			
						} else {			
							$paged = 1;			
						}			
						
						// #PAGINATION	
											
						/* STICKY POST DA FARE ARRAY PER SCRITTURA IN ARRAY */
					
						$sticky = get_option( 'sticky_posts' );
						$sticky = array_slice( $sticky, 0, 5 );
						if($view_order == 'views') { 
							$query = array(
								'post_type' => 'post',
								'post_status' => 'publish',
								'orderby' 	=> $orderby,
								'order' => $order,
								'category_name' => $categories,
								'posts_per_page' => $num_posts,
								'meta_key' => 'wpb_post_views_count',
								'paged' => $paged, 
								'post__in'  => $sticky,
								'ignore_sticky_posts' => 1
							);
						} else {
							$query = array(
								'post_type' => 'post',
								'post_status' => 'publish',
								'orderby' 	=> $orderby,
								'order' => $order,
								'category_name' => $categories,
								'posts_per_page' => $num_posts,
								'paged' => $paged, 
								'post__in'  => $sticky,
								'ignore_sticky_posts' => 1
							);
						}						
						
					} // #all_posts
					
					
					return $query;	
}


/************************************************************/
/******************* NUMERIC PAGINATION *********************/
/************************************************************/

function wpmegapack_vc_numeric_pagination($pages = '', $range = 2,$loop)
{  
     $showitems = ($range * 2)+1;  

     global $paged;
     if(empty($paged)) $paged = 1;

     if($pages == '')
     {
         $pages = $loop->max_num_pages;
         if(!$pages)
         {
             $pages = 1;
         }
     }   
	
	 $return = '';
	
     if(1 != $pages)
     {		 	
         $return .= "<div class='wpmp-pagination'>";
         if($paged > 2 && $paged > $range+1 && $showitems < $pages) $return .=  "<a href='".get_pagenum_link(1)."'>&laquo;</a>";
         if($paged > 1 && $showitems < $pages) $return .=  "<a href='".get_pagenum_link($paged - 1)."'>&lsaquo;</a>";

         for ($i=1; $i <= $pages; $i++)
         {
             if (1 != $pages &&( !($i >= $paged+$range+1 || $i <= $paged-$range-1) || $pages <= $showitems ))
             {
                 $return .=  ($paged == $i)? "<span class='current'>".$i."</span>":"<a href='".get_pagenum_link($i)."' class='inactive' >".$i."</a>";
             }
         }

         if ($paged < $pages && $showitems < $pages) $return .= "<a href='".get_pagenum_link($paged + 1)."'>&rsaquo;</a>";  
         if ($paged < $pages-1 &&  $paged+$range-1 < $pages && $showitems < $pages) $return .=  "<a href='".get_pagenum_link($pages)."'>&raquo;</a>";
         $return .=  "</div>\n";
     }
	 
	 return $return;
}









/***********************************************************/
/************* MENU OPTIONS FUNCTION ***********************/
/***********************************************************/

add_action('admin_menu', 'wpmegapack_vc_menus');

function wpmegapack_vc_menus() {
	
    add_submenu_page( 
        'edit.php?post_type=adt_wpmegapack_vc',
        __('Settings','wpmegapack_vc'),
        __('Settings','wpmegapack_vc'),
        'manage_options',
        'wpmegapack_vc_main_page',
        'wpmegapack_vc_main_page'
    );		
}

function wpmegapack_vc_main_page() {
	
	
	if (!current_user_can('manage_options'))  {

		wp_die( __('You do not have sufficient permissions to access this page.', 'vconepage') );

	}
	
	echo '<div class="vcop_row">
			<h2 class="adsidebarpanel-title">'.__('WORDPRESS MEGA PACK SETTINGS','vconepage').'</h2>
		  </div>';
	
	echo '<style type="text/css">
			  .wpmp-clear {
				  clear:both;
			  }
			  .wpmp_row {
					width:100%;
					padding:25px 25px 0 25px;
					box-sizing:border-box;  
			  }
			  .wpmp_element, .vcop_capability {
					width:50%;
					float:left;  
			  }
			  .wpmp_element_title {
				display: inline-block;
				width: 200px;
			  }
			  .wpmp_element_sub_title {
				display: inline-block;
			  }
			  .vcop_row h2 {
				    padding:30px;
				  	font-size:40px;
					display:block;
					color:#e74c3c;
			  }
			 .wpmp_element_title {
					background: #fff none repeat scroll 0 0;
					display: inline-block;
					font-weight: 800;
					height: 32px;
					line-height: 32px;
					padding-left: 12px;
					text-transform: uppercase;
					width: 200px;
			 }
			 .wp-admin.post-type-adt_wpmegapack_vc select {
					border: medium none;
					height: 32px;
					line-height: 32px;
					margin-top: -2px;
					padding: 0 0 0 12px;
					box-shadow: none;
			 }	
			 .post-type-adt_wpmegapack_vc .wp-color-result::after {
					background: #ffffff none repeat scroll 0 0;
					border-left: 1px solid #ccc;
					border-radius: 0 2px 2px 0;
					color: #555;
					content: attr(title);
					display: block;
					font-size: 11px;
					font-weight: 800;
					line-height: 32px;
					padding: 0 12px;
					position: relative;
					right: 0;
					text-align: center;
					text-transform: uppercase;
					top: 0;
			 }
			 .post-type-adt_wpmegapack_vc .wp-color-result {
					-moz-user-select: none;
					background-color: #fff;
					border: 1px solid #ccc;
					cursor: pointer;
					display: inline-block;
					height: 32px;
					margin: 0 6px 6px 0;
					padding-left: 30px;
					position: relative;
					top: 14px;
					vertical-align: bottom;
			 }
			 .post-type-adt_wpmegapack_vc .wp-picker-container input.wp-color-picker[type="text"] {
					box-shadow: none;
					font-family: monospace;
					font-size: 12px;
					height: 32px;
					line-height: 16px;
					margin: 14px 0 0;
					width: 65px;
			 }
			 .wp-core-ui.post-type-adt_wpmegapack_vc .button-group.button-small .button, 
			 .wp-core-ui.post-type-adt_wpmegapack_vc .button.button-small {
					border-radius: 0;
					font-size: 11px;
					font-weight: 800;
					height: 32px;
					line-height: 22px;
					margin-top: 14px;
					padding: 0 12px 1px;
					text-transform: uppercase;
			 }
			.wp-picker-container.wp-picker-active .wp-color-result.wp-picker-open {
				box-shadow: none;
				top: 6px;
			}
			.post-type-adt_wpmegapack_vc .wp-picker-container input.wp-color-picker[type="text"] {
				height: 34px;
			}						 			 			 			 			 		 			  
		  </style>
		  <script type="text/javascript">
		  jQuery(document).ready(function($){
					$(\'#wpmp_widget_custom_color\').on(\'click\', function(event) {
						var widget_custom_color = $(\'#wpmp_widget_custom_color\').val();
		 				if(widget_custom_color == \'on\') {
							$(\'.wpmp_container_color\').css("display","block");
						} else {
							$(\'.wpmp_container_color\').css("display","none");
						}
					});		  
		  
		  });
		  </script>';
	
	if (!empty($_POST['update'])) {

		if(empty($_POST['wpmp_widget_active'])) {$wpmp_widget_active = '';} else { $wpmp_widget_active = $_POST['wpmp_widget_active']; }
		update_option('wpmp_widget_active', $wpmp_widget_active );		

		if(empty($_POST['wpmp_widget_custom_color'])) {$wpmp_widget_custom_color = '';} else { $wpmp_widget_custom_color = $_POST['wpmp_widget_custom_color']; }
		update_option('wpmp_widget_custom_color', $wpmp_widget_custom_color );	

		if(empty($_POST['wpmp_widget_maincolor'])) {$wpmp_widget_maincolor = '';} else { $wpmp_widget_maincolor = $_POST['wpmp_widget_maincolor']; }
		update_option('wpmp_widget_maincolor', $wpmp_widget_maincolor );	

		if(empty($_POST['wpmp_widget_secondcolor'])) {$wpmp_widget_secondcolor = '';} else { $wpmp_widget_secondcolor = $_POST['wpmp_widget_secondcolor']; }
		update_option('wpmp_widget_secondcolor', $wpmp_widget_secondcolor );
		
		if(empty($_POST['wpmp_widget_thirdcolor'])) {$wpmp_widget_thirdcolor = '';} else { $wpmp_widget_thirdcolor = $_POST['wpmp_widget_thirdcolor']; }
		update_option('wpmp_widget_thirdcolor', $wpmp_widget_thirdcolor );
	
	}
	
	$wpmp_widget_active = get_option( 'wpmp_widget_active', '' );
	update_option('wpmp_widget_active', $wpmp_widget_active );		

	$wpmp_widget_custom_color = get_option( 'wpmp_widget_custom_color', '' );
	update_option('wpmp_widget_custom_color', $wpmp_widget_custom_color );

	$wpmp_widget_maincolor = get_option( 'wpmp_widget_maincolor', '' );
	update_option('wpmp_widget_maincolor', $wpmp_widget_maincolor );	

	$wpmp_widget_secondcolor = get_option( 'wpmp_widget_secondcolor', '' );
	update_option('wpmp_widget_secondcolor', $wpmp_widget_secondcolor );	
	
	$wpmp_widget_thirdcolor = get_option( 'wpmp_widget_thirdcolor', '' );
	update_option('wpmp_widget_thirdcolor', $wpmp_widget_thirdcolor );

	// Load option fields
	echo '<form method="POST" action="'.$_SERVER['REQUEST_URI'].'">';
	?>

    <div class="wpmp_row">
    
        <div class="wpmp_element">  
            <span class="wpmp_element_title"><?php _e('Widget: ', 'wpmegapck'); ?></span>
            <select id="wpmp_widget_active" name="wpmp_widget_active">
                <option value="active" <?php if ($wpmp_widget_active == 'active') { echo 'selected'; } ?>>Active
                <option value="deactive" <?php if ($wpmp_widget_active == 'deactive') { echo 'selected'; } ?>>Deactive
            </select>
        </div>
        
    </div>
    
    <div class="wpmp-clear"></div>
    
    <div class="wpmp_row">
    	<h1><?php echo __('Widget Color','wpmegapack_vc'); ?></h1>
        <div class="wpmp_element_container_color">  
            <span class="wpmp_element_title"><?php echo __('Widget custom color','wpmegapack_vc'); ?></span>
            <select id="wpmp_widget_custom_color" name="wpmp_widget_custom_color">  
                
                       <option value="off" <?php if ($wpmp_widget_custom_color == 'off') { echo 'selected'; } ?>><?php _e('Default Color', 'wpmegapack_vc'); ?></option>
                       <option value="on" <?php if ($wpmp_widget_custom_color == 'on') { echo 'selected'; } ?>><?php _e('Custom Color', 'wpmegapack_vc'); ?></option>
                
            </select>        
        </div>
        <?php $class_container_custom_color = ''; if ($wpmp_widget_custom_color == 'off') { $class_container_custom_color = 'style="display:none"'; } ?>
        
        <div class="wpmp_container_color" <?php echo $class_container_custom_color; ?>>
        
            <div class="wpmp_element_container_color">  
                        <span class="wpmp_element_title"><?php _e('Main Color','wpmegapack_vc'); ?></span>
                        <input type="text" value="<?php echo $wpmp_widget_maincolor; ?>" class="wp-color-picker-field" data-default-color="#eeeeee" id="wpmp_widget_maincolor" name="wpmp_widget_maincolor" /> 
            </div>
    
            <div class="wpmp_element_container_color">  
                        <span class="wpmp_element_title"><?php _e('Secondary Color','wpmegapack_vc'); ?></span>
                        <input type="text" value="<?php echo $wpmp_widget_secondcolor; ?>" class="wp-color-picker-field" data-default-color="#eeeeee" id="wpmp_widget_secondcolor" name="wpmp_widget_secondcolor" /> 
            </div>
            
            <div class="wpmp_element_container_color">  
                        <span class="wpmp_element_title"><?php _e('Third Color','wpmegapack_vc'); ?></span>
                        <input type="text" value="<?php echo $wpmp_widget_thirdcolor; ?>" class="wp-color-picker-field" data-default-color="#eeeeee" id="wpmp_widget_thirdcolor" name="wpmp_widget_thirdcolor" /> 
            </div>
                        
        	
        </div>
        
    </div>  
    
	<?php
	echo '<div class="wpmp_row"><p><input type="hidden" name="update" value="update">
	<input type="submit" value="'.__('Save Changes', 'wpmegapack_vc').'" class="button-primary" id="submit" name="submit">
	</p>';
	echo '</form>';
	echo '</div>';

}	// CLOSE wpmegapack_vc_main_page()

/**************************************************************************/
/*********************** REGISTER CUSTOM POST TYPE ************************/
/**************************************************************************/

add_action( 'init', 'adf_wpmegapack_vc_register_posttype' );

function adf_wpmegapack_vc_register_posttype() {

	$labels = array(
		'name'               => __('WP VC Mega Pack', 'wpmegapack_vc'),
		'singular_name'      => __('Shortcode', 'wpmegapack_vc'),
		'add_new'            => __('Create New Shortcode', 'wpmegapack_vc'),
		'add_new_item'       => __('Create New Shortcode', 'wpmegapack_vc'),
		'edit_item'          => __('Edit Shortcode', 'wpmegapack_vc'),
		'new_item'           => __('New Shortcode', 'wpmegapack_vc'),
		'all_items'          => __('All Shortcodes', 'wpmegapack_vc'),
		'view_item'          => __('View Shortcode', 'wpmegapack_vc'),
		'search_items'       => __('Search Shortcode', 'wpmegapack_vc'),
		'not_found'          => __('No Shortcode found', 'wpmegapack_vc'),
		'not_found_in_trash' => __('No Shortcode found in Trash', 'wpmegapack_vc'),
		'parent_item_colon'  => '',
		'menu_name'          => __('WP VC Mega Pack', 'wpmegapack_vc')
	  );
	
	  $args = array(
		'labels'             => $labels,
		'public'             => true,
		'publicly_queryable' => true,
		'show_ui'            => true,
		'show_in_menu'       => true,
		'query_var'          => true,
		'rewrite'            => array( 'slug' => 'adt_wpmegapack_vc' ),
		'capability_type'    => 'post',
		'has_archive'        => true,
		'hierarchical'       => false,
		'show_in_admin_bar'	 => false,
		'menu_position'      => null,		
		'menu_icon'			 => plugins_url( 'wpmegapack_vc/assets/img/wpmegapack.png'),
		'supports'           => array('title','editor' )
	  );
	
	  register_post_type( 'adt_wpmegapack_vc', $args );

}


function widget_vc_custom_color($wpmp_widget_custom_color,
							 $wpmp_widget_maincolor,
							 $wpmp_widget_secondcolor,
							 $wpmp_widget_thirdcolor) {

			$return = '';

			if($wpmp_widget_custom_color == 'on') {
				
				$return .= '<style>';	
				$return .= '.wpmp-widget h3.widget-title,
							.wpmp-widget h4.widget-title {
									border-right: 5px solid '.$wpmp_widget_maincolor.'!important;
							}
							.wpmp-title-widget,
							.wpmegapack_vc.wpmp_archivies .box_archivies .box_archivies_item:hover,
							.wpmegapack_vc.wpmp_categories .box_categories .cat-item:hover,
							.wpmegapack_vc.wpmp_slider_posts .category a:hover,
							.wpmegapack_vc.wpmp_tab .content_tag {
									background:'.$wpmp_widget_maincolor.'!important;
							}
							.wpmegapack_vc.wpmp_mega_posts .container_post.ad_one_one .icon-calendar,
							.wpmegapack_vc.wpmp_slider_posts .box-text h3 a:hover,
							.wpmegapack_vc.wpmp_slider_posts .data:hover,
							.wpmegapack_vc.wpmp_slider_posts .icon-calendar,
							.wpmegapack_vc.wpmp_tab .container_post.ad_one_one .icon-calendar {
									color:'.$wpmp_widget_maincolor.'!important;
							}
							.wpmegapack_vc.wpmp_slider_posts .category a {
									border-left:5px solid '.$wpmp_widget_maincolor.'!important;
							}
							.wpmp-title-widget {
									color:'.$wpmp_widget_secondcolor.'!important;
							}
							.wpmegapack_vc.wpmp_advertisement .box_advertisement,
							.wpmegapack_vc.wpmp_archivies .box_archivies,
							.wpmegapack_vc.wpmp_categories .box_categories,
							.wpmegapack_vc.wpmp_flickr .box_flickr,
							.wpmegapack_vc.wpmp_mega_posts .box_post,
							.wpmegapack_vc.wpmp_slider_posts .box-text,
							.wpmegapack_vc.wpmp_social .box_social,
							.wpmegapack_vc.wpmp_tab .box_post,
							.wpmegapack_vc.wpmp_tab .box_tag {
									background:'.$wpmp_widget_secondcolor.'!important;
							}
							.wpmegapack_vc.wpmp_archivies .box_archivies_item:hover a,
							.wpmegapack_vc.wpmp_archivies .box_archivies .box_archivies_item:hover,
							.wpmegapack_vc.wpmp_archivies .box_archivies .box_archivies_item:hover,
							.wpmegapack_vc.wpmp_categories .cat-item:hover a,
							.wpmegapack_vc.wpmp_categories .box_categories .cat-item:hover,
							.wpmegapack_vc.wpmp_categories .box_categories .cat-item:hover,
							.wpmegapack_vc.wpmp_slider_posts .category a,
							.wpmegapack_vc.wpmp_slider_posts .category a:hover,
							.wpmegapack_vc.wpmp_slider_posts .wpmegapack_vc-item.ad_one_one.ad_last.big-post i,
							.wpmegapack_vc.wpmp_social .box-icon-social a,
							.wpmegapack_vc.wpmp_social .box-icon-social p,
							.wpmegapack_vc.wpmp_tab .content_tag,
							.wpmegapack_vc.wpmp_tab .content_tag a {
									color:'.$wpmp_widget_secondcolor.'!important;
							}				
							.wpmegapack_vc.wpmp_archivies .box_archivies .box_archivies_item,
							.wpmegapack_vc.wpmp_archivies a,
							.wpmegapack_vc.wpmp_archivies .number-post,
							.wpmegapack_vc.wpmp_categories .box_categories .cat-item,
							.wpmegapack_vc.wpmp_categories a,
							.wpmegapack_vc.wpmp_categories .number-post,
							.wpmegapack_vc.wpmp_mega_posts .container_post.ad_one_one .box-info h4 a,
							.wpmegapack_vc.wpmp_slider_posts .box-text h3 a,
							.wpmegapack_vc.wpmp_tab .container_post.ad_one_one .box-info h4 a,
							.wpmegapack_vc.wpmp_tab .container_post.ad_one_one .box-info a:hover,
							.wpmegapack_vc.wpmp_tab .container_post.ad_one_one .data,
							.wpmegapack_vc.wpmp_mega_posts .container_post.ad_one_one .box-info a:hover
							.wpmegapack_vc.wpmp_tab .container_post.ad_one_one .data {
									color:'.$wpmp_widget_thirdcolor.'!important;
							}';
					
				$return .= '</style>';
			}

								
			return $return;					
}

add_filter('user_can_richedit', 'wpmegapack_vc_disable_wyswyg_for_custom_post_type');
function wpmegapack_vc_disable_wyswyg_for_custom_post_type( $default ){
  if( get_post_type() === 'adt_wpmegapack_vc') return false;
  return $default;
}

function wpmegapack_vc_check_post_type_and_remove_media_buttons() {
	global $current_screen;
	if( 'adt_wpmegapack_vc' == $current_screen->post_type ) remove_action('media_buttons', 'media_buttons');
}
add_action('admin_head','wpmegapack_vc_check_post_type_and_remove_media_buttons');

/**************************************************************************/
/******************* HIDE PERMALINK CUSTOM POST TYPE **********************/
/**************************************************************************/

add_filter('get_sample_permalink_html', 'adt_wpmegapack_vc_hide_permalinks', 10, 5);

function adt_wpmegapack_vc_hide_permalinks($return, $post_id, $new_title, $new_slug, $post)
{
    if($post->post_type == 'adt_wpmegapack_vc') {
        return '';
    }
    return $return;
}

/**************************************************************************/
/**************************** SHORTCODE BY ID *****************************/
/**************************************************************************/

add_action('admin_init', 'wpmegapack_vc_add_metabox', 1);
function wpmegapack_vc_add_metabox() {
	add_meta_box( 	'wpmegapack_vc_metabox_options', 
			'Shortcode Name', 
			'wpmegapack_vc_metabox_shortcode', 
			'adt_wpmegapack_vc', 
			'normal', 
			'high'
	);
}

function wpmegapack_vc_metabox_shortcode() {
	global $post;
	$wpmegapack_vc_metabox_shortcode = get_post_meta($post->ID, 'wpmegapack_vc_metabox_shortcode', true);
	wp_nonce_field( 'wpmegapack_vc_metabox_shortcode_nonce', 'wpmegapack_vc_metabox_shortcode_nonce' );

?>
        <h2><?php echo __('Shortcode (Copy and past it)'); ?></h2>
        <input readonly type="text" id="wpmegapack_vc_metabox_shortcode" name="wpmegapack_vc_metabox_shortcode" value='[wpmp_vc_by_id id="<?php echo get_the_id(); ?>"]' size="25">

<?php

}

add_action('save_post', 'wpmegapack_vc_metabox_shortcode_save');
function wpmegapack_vc_metabox_shortcode_save($post_id) {   
	if ( ! isset( $_POST['wpmegapack_vc_metabox_shortcode_nonce'] ) ||
	! wp_verify_nonce( $_POST['wpmegapack_vc_metabox_shortcode_nonce'], 'wpmegapack_vc_metabox_shortcode_nonce' ) )
		return;
	
	if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE)
		return;
	
	if (!current_user_can('edit_post', $post_id))
		return;
	
  	$wpmegapack_vc_metabox_shortcode = $_POST['wpmegapack_vc_metabox_shortcode'];
  	update_post_meta( $post_id, 'wpmegapack_vc_metabox_shortcode', $wpmegapack_vc_metabox_shortcode );	

}

function wpmp_vc_by_id ( $attr ) {
	
		extract(
			shortcode_atts(
				array(
					"id" => ''
					), 
					$attr)
		);		
		
		$content = get_post_field('post_content', $id);
		
		$content = str_replace('&nbsp;', '', $content);
		
		$return = do_shortcode($content);
	
		return $return;
}


add_shortcode("wpmp_vc_by_id", "wpmp_vc_by_id");

/**************************************************************************/
/********************** FUNCTION ADD COLUMNS ******************************/
/**************************************************************************/

add_filter('manage_adt_wpmegapack_vc_posts_columns', 'adt_wpmegapack_vc_columns_head');
add_action('manage_adt_wpmegapack_vc_posts_custom_column', 'adt_wpmegapack_vc_columns_content', 10, 2);

function adt_wpmegapack_vc_columns_head($defaults) {
    $defaults['shortcodes'] = 'Shortcode';
    return $defaults;
}

function adt_wpmegapack_vc_columns_content($column_name, $post_ID) {
    if ($column_name == 'shortcodes') {
		echo '[wpmp_by_id id="'.get_the_id().'"]';
    }
}

function add_adt_wpmegapack_vc_columns($columns) {
    return array_merge($columns, 
              array('shortcodes' => __('Shortcodes')));
}
add_filter('manage_adt_wpmegapack_vc_posts_columns' , 'add_adt_wpmegapack_vc_columns');

function set_adt_wpmegapack_vc_columns($columns) {
    return array(
        'cb' => '<input type="checkbox" />',
        'title' => __('Title'),
		'shortcodes' => __('Shortcodes'),
        'date' => __('Date'),
    );
}
add_filter('manage_adt_wpmegapack_vc_posts_columns' , 'set_adt_wpmegapack_vc_columns');

add_filter('widget_text', 'do_shortcode');

?>