<?php

class wpmegapack_vc_news_ticker_class {
    function __construct() {
        add_action( 'init', array( $this, 'integrate_wpmegapack_vc_news_tickerWithVC' ) );
        add_shortcode( 'wpmp_news_ticker_vc', array( $this, 'wpmegapack_vc_news_ticker_function' ) );	
    }
 
    public function integrate_wpmegapack_vc_news_tickerWithVC() {
        if ( ! defined( 'WPB_VC_VERSION' ) ) {
            return;
        }
		
		vc_map( array(
            "name" => __("WP NEWS TICKER", 'wpmegapack_vc'),
            "description" => __("news ticker", 'wpmegapack_vc'),
            "base" => "wpmp_news_ticker_vc",
            "class" => "adtheme",
            "controls" => "full",
            "icon" => plugins_url('wpmegapack_vc/assets/img/wpmegapack_vc.png'),
            "category" => __('WP MEGA PACK', 'js_composer'),
            "params" => array(						
				array(
						"type" => "textfield",
						"class" => "",
						"heading" => __("News Ticker Name",'wpmegapack_vc'),
						"param_name" => "name",
						"admin_label" => true,				  				  			  				  
				),		
               array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Show Date", 'wpmegapack_vc'),
                  "param_name" => "date",
                  "value" => array(
				  					__('Show','wpmegapack_vc') 			=> 'true',
									__('Hidden','wpmegapack_vc')  		=> 'false',
				   ),			   				   			   
				),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Date Format", 'wpmegapack_vc'),
                  "param_name" => "date_format",
                  "value" => array(
				  					__('November 6, 2010 12:50 am','wpmegapack_vc') 		=> 'F j, Y g:i a',
									__('November 6, 2010','wpmegapack_vc')  				=> 'F j, Y',
				  					__('November, 2010','wpmegapack_vc') 					=> 'F, Y',
									__('12:50 am','wpmegapack_vc')  						=> 'g:i a',
				  					__('12:50:48 am','wpmegapack_vc') 						=> 'g:i:s a',
									__('Saturday, November 6th, 2010','wpmegapack_vc')  	=> 'l, F jS, Y',
				  					__('Nov 6, 2010 @ 0:50','wpmegapack_vc') 				=> 'M j, Y @ G:i',
									__('2010/11/06 at 12:50 AM','wpmegapack_vc')  			=> 'Y/m/d \a\t g:i A',
				  					__('2010/11/06 at 12:50am','wpmegapack_vc') 			=> 'Y/m/d \a\t g:ia',
									__('2010/11/06 12:50:48 AM','wpmegapack_vc')  			=> 'Y/m/d g:i:s A',
									__('2010/11/06','wpmegapack_vc')  						=> 'Y/m/d',																																														
				   ),
				  "dependency" => array(
							'element' => 'date',
							'value' => array( 'true' )
					),					   				   			   
				),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Show Category", 'wpmegapack_vc'),
                  "param_name" => "category_show",
                  "value" => array(
				  					__('Show','wpmegapack_vc') 		=> 'true',
									__('Hidden','wpmegapack_vc')  	=> 'false',
				   ),			   				   			   
				),
				
                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Show Social", 'wpmegapack_vc'),
                  "param_name" => "social",
                  "value" => array(
				  					__('Show','wpmegapack_vc') 		=> 'true',
									__('Hidden','wpmegapack_vc')  	=> 'false',
				   ),					   			   			   
				),
														
				// QUERY
                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Source", 'wpmegapack_vc'),
                  "param_name" => "source",
                  "value" => array(
				  					__('Wordpress Posts','wpmegapack_vc') 	=> 'post',
									__('Custom Posts Type','wpmegapack_vc')  	=> 'post_type',
				   ),
				   "group" => "Query"				   			   
				),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("All Posts/Sticky posts", 'wpmegapack_vc'),
                  "param_name" => "posts_source",
                  "value" => array(
				  					__('All Posts','wpmegapack_vc') 		 	=> 'all_posts',
									__('Only Sticky Posts','wpmegapack_vc')  	=> 'sticky_posts',
				   ),
				   "group" => "Query",
				  "dependency" => array(
							'element' => 'source',
							'value' => array( 'post' )
				  ),					   				   			   
				),

			    array(
				  "type" => "posttypes", 
				  "class" => "",
				  "heading" => __("Select Post Type Source",'wpmegapack_vc'),
				  "param_name" => "posts_type",
				  "group" => "Query",
				  "dependency" => array(
							'element' => 'source',
							'value' => array( 'post_type' )
				  ),					  				  					  				  			  				  
			    ),

			    array(
				  "type" => "textfield", 
				  "class" => "",
				  "heading" => __("Categories",'wpmegapack_vc'),
				  "param_name" => "categories",
				  "description" => __("Write Categories slug separate by comma(,) for example: cat-slug1, cat-slug2, cat-slug3 (Leave empty for all categories)","wpmegapack_vc"),
				  "group" => "Query", 
				  "dependency" => array(
							'element' => 'source',
							'value' => array( 'post' )
				  ),				  					  				  					  				  			  				  
			    ),

			    array(
				  "type" => "textfield", 
				  "class" => "",
				  "heading" => __("Categories Posts Type",'wpmegapack_vc'),
				  "param_name" => "categories_post_type",
				  "description" => __("Write Categories slug separate by comma(,) for example: cat-slug1, cat-slug2, cat-slug3 (Leave empty for all categories)","wpmegapack_vc"),
				  "group" => "Query",
				  "dependency" => array(
							'element' => 'source',
							'value' => array( 'post_type' )
				  ),				  					  				  					  				  			  				  
			    ),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Order", 'wpmegapack_vc'),
                  "param_name" => "order",
                  "value" => array(
				  					__('DESC','wpmegapack_vc')  => 'DESC',
				  					__('ASC','wpmegapack_vc') 	=> 'ASC'
									
				   ),
				   "group" => "Query"				   			   
				),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Order By", 'wpmegapack_vc'),
                  "param_name" => "orderby",
                  "value" => array(
				  					__('Date','wpmegapack_vc') 				=> 'date',
									__('ID','wpmegapack_vc')  				=> 'ID',
				  					__('Author','wpmegapack_vc') 			=> 'author',
									__('Title','wpmegapack_vc')  			=> 'title',
				  					__('Name','wpmegapack_vc') 				=> 'name',
									__('Modified','wpmegapack_vc')  		=> 'modified',
				  					__('Parent','wpmegapack_vc') 			=> 'parent',
									__('Rand','wpmegapack_vc')  			=> 'rand',
									__('Comments Count','wpmegapack_vc')  	=> 'comment_count',
									__('Views','wpmegapack_vc')				=> 'views',
									__('None','wpmegapack_vc')  			=> 'none',																																													
				   ),
				   "group" => "Query"				   			   
				),
				
				// STYLE
				
                array(
                  	"type" => "dropdown",
                  	"class" => "",
                  	"heading" => __("Custom Style", 'wpmegapack_vc'),
                  	"param_name" => "custom_style",
                  	"value" => array(
									__('Off','wpmegapack_vc')  		=> 'off',
				  					__('On','wpmegapack_vc') 		=> 'on',
									
				  	),
				  	"group" => "Style",				   				   			   
				),				
				
				array(
				  	"type" => "colorpicker",
				  	"class" => "",
				  	"heading" => __("Main Color", 'wpmegapack_vc'),
				  	"param_name" => "maincolor",
					"value" => '#e74c3c',
					"group" => "Style",
				  	"dependency" => array(
							'element' => 'custom_style',
							'value' => array( 'on' )
				  	),					
				),				
				
				array(
				  	"type" => "colorpicker",
				  	"class" => "",
				  	"heading" => __("Second Color", 'wpmegapack_vc'),
				  	"param_name" => "secondarycolor",
					"value" => '#FFFFFF',
					"group" => "Style",
				  	"dependency" => array(
							'element' => 'custom_style',
							'value' => array( 'on' )
				  	),					
				),	
				
				array(
				  	"type" => "colorpicker",
				  	"class" => "",
				  	"heading" => __("Third Color", 'wpmegapack_vc'),
				  	"param_name" => "thirdcolor",
					"value" => '#000000',
					"group" => "Style",
				  	"dependency" => array(
							'element' => 'custom_style',
							'value' => array( 'on' )
				  	),					
				),									
				
				
				// CAROUSEL								
				
				array(
					  "type" => "textfield",
					  "class" => "",
					  "heading" => __("Autoplay",'wpmegapack_vc'),
					  "param_name" => "autoplay",
					  "description" => "ex 2000 or Leave empty for default",					  
					  "group" => "Carousel Settings"				  					  
				),												

				array(
					  "type" => "textfield",
					  "class" => "",
					  "heading" => __("Speed",'wpmegapack_vc'),
					  "param_name" => "speed",
					  "description" => "ex 2000 or Leave empty for default",					  
					  "group" => "Carousel Settings"				  					  
				),	
				
		)		
		) // CLOSE VC MAP
	  );
    }					
}
// Finally initialize code
new wpmegapack_vc_news_ticker_class();
?>