<?php

class wpmegapack_vc_post_display_class {
    function __construct() {
        add_action( 'init', array( $this, 'integrate_wpmegapack_vc_post_displayWithVC' ) );
        add_shortcode( 'wpmp_post_display_vc', array( $this, 'wpmegapack_vc_post_display_function' ) );	
    }
 
    public function integrate_wpmegapack_vc_post_displayWithVC() {
        if ( ! defined( 'WPB_VC_VERSION' ) ) {
            return;
        }
		
		vc_map( array(
            "name" => __("WP POST DISPLAY", 'wpmegapack_vc'),
            "description" => __("display your posts", 'wpmegapack_vc'),
            "base" => "wpmp_post_display_vc",
            "class" => "adtheme",
            "controls" => "full",
            "icon" => plugins_url('wpmegapack_vc/assets/img/wpmegapack_vc.png'),
            "category" => __('WP MEGA PACK', 'js_composer'),
            "params" => array(						
				array(
						"type" => "textfield",
						"class" => "",
						"heading" => __("Post Display Name",'wpmegapack_vc'),
						"param_name" => "name",
						"admin_label" => true,				  				  			  				  
				),		
                array(		
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => __("Type", 'wpmegapack_vc'),
					  "param_name" => "type",
					  "value" => array(
										__('Type 1','wpmegapack_vc') 	=> 'type1',
										__('Type 2','wpmegapack_vc')  	=> 'type2',
										__('Type 3','wpmegapack_vc')  	=> 'type3',
										__('Type 4','wpmegapack_vc') 	=> 'type4',
										__('Type 5','wpmegapack_vc')  	=> 'type5',
										__('Type 6','wpmegapack_vc')  	=> 'type6',
										__('Type 7','wpmegapack_vc') 	=> 'type7',
										__('Type 8','wpmegapack_vc')  	=> 'type8',
										__('Type 9','wpmegapack_vc') 	=> 'type9',
										__('Type 10','wpmegapack_vc')  	=> 'type10'																																											
					   ),			   
				),
               array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Show Date", 'wpmegapack_vc'),
                  "param_name" => "date",
                  "value" => array(
				  					__('Show','wpmegapack_vc') 			=> 'true',
									__('Hidden','wpmegapack_vc')  		=> 'false',
				   ),			   				   			   
				),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Date Format", 'wpmegapack_vc'),
                  "param_name" => "date_format",
                  "value" => array(
				  					__('November 6, 2010 12:50 am','wpmegapack_vc') 		=> 'F j, Y g:i a',
									__('November 6, 2010','wpmegapack_vc')  				=> 'F j, Y',
				  					__('November, 2010','wpmegapack_vc') 					=> 'F, Y',
									__('12:50 am','wpmegapack_vc')  						=> 'g:i a',
				  					__('12:50:48 am','wpmegapack_vc') 						=> 'g:i:s a',
									__('Saturday, November 6th, 2010','wpmegapack_vc')  	=> 'l, F jS, Y',
				  					__('Nov 6, 2010 @ 0:50','wpmegapack_vc') 				=> 'M j, Y @ G:i',
									__('2010/11/06 at 12:50 AM','wpmegapack_vc')  			=> 'Y/m/d \a\t g:i A',
				  					__('2010/11/06 at 12:50am','wpmegapack_vc') 			=> 'Y/m/d \a\t g:ia',
									__('2010/11/06 12:50:48 AM','wpmegapack_vc')  			=> 'Y/m/d g:i:s A',
									__('2010/11/06','wpmegapack_vc')  						=> 'Y/m/d',																																														
				   ),
				  "dependency" => array(
							'element' => 'date',
							'value' => array( 'true' )
					),					   				   			   
				),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Show Comments", 'wpmegapack_vc'),
                  "param_name" => "comments",
                  "value" => array(
				  					__('Show','wpmegapack_vc') 		=> 'true',
									__('Hidden','wpmegapack_vc')  	=> 'false',
				   ),			   				   			   
				),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Show Author", 'wpmegapack_vc'),
                  "param_name" => "author",
                  "value" => array(
				  					__('Show','wpmegapack_vc') 		=> 'true',
									__('Hidden','wpmegapack_vc')  	=> 'false',
				   ),			   				   			   
				),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Show Category", 'wpmegapack_vc'),
                  "param_name" => "category_show",
                  "value" => array(
				  					__('Show','wpmegapack_vc') 		=> 'true',
									__('Hidden','wpmegapack_vc')  	=> 'false',
				   ),			   				   			   
				),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Show Views", 'wpmegapack_vc'),
                  "param_name" => "views",
                  "value" => array(
				  					__('Show','wpmegapack_vc') 		=> 'true',
									__('Hidden','wpmegapack_vc')  	=> 'false',
				   ),					   			   			   
				),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Show Social", 'wpmegapack_vc'),
                  "param_name" => "social",
                  "value" => array(
				  					__('Show','wpmegapack_vc') 		=> 'true',
									__('Hidden','wpmegapack_vc')  	=> 'false',
				   ),					   			   			   
				),
														
				// QUERY
                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Source", 'wpmegapack_vc'),
                  "param_name" => "source",
                  "value" => array(
				  					__('Wordpress Posts','wpmegapack_vc') 	=> 'post',
									__('Custom Posts Type','wpmegapack_vc')  	=> 'post_type',
				   ),
				   "group" => "Query"				   			   
				),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("All Posts/Sticky posts", 'wpmegapack_vc'),
                  "param_name" => "posts_source",
                  "value" => array(
				  					__('All Posts','wpmegapack_vc') 		 	=> 'all_posts',
									__('Only Sticky Posts','wpmegapack_vc')  	=> 'sticky_posts',
				   ),
				   "group" => "Query",
				  "dependency" => array(
							'element' => 'source',
							'value' => array( 'post' )
				  ),					   				   			   
				),

			    array(
				  "type" => "posttypes", 
				  "class" => "",
				  "heading" => __("Select Post Type Source",'wpmegapack_vc'),
				  "param_name" => "posts_type",
				  "group" => "Query",
				  "dependency" => array(
							'element' => 'source',
							'value' => array( 'post_type' )
				  ),					  				  					  				  			  				  
			    ),

			    array(
				  "type" => "textfield", 
				  "class" => "",
				  "heading" => __("Categories",'wpmegapack_vc'),
				  "param_name" => "categories",
				  "description" => __("Write Categories slug separate by comma(,) for example: cat-slug1, cat-slug2, cat-slug3 (Leave empty for all categories)","wpmegapack_vc"),
				  "group" => "Query", 
				  "dependency" => array(
							'element' => 'source',
							'value' => array( 'post' )
				  ),				  					  				  					  				  			  				  
			    ),

			    array(
				  "type" => "textfield", 
				  "class" => "",
				  "heading" => __("Categories Posts Type",'wpmegapack_vc'),
				  "param_name" => "categories_post_type",
				  "description" => __("Write Categories slug separate by comma(,) for example: cat-slug1, cat-slug2, cat-slug3 (Leave empty for all categories)","wpmegapack_vc"),
				  "group" => "Query",
				  "dependency" => array(
							'element' => 'source',
							'value' => array( 'post_type' )
				  ),				  					  				  					  				  			  				  
			    ),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Order", 'wpmegapack_vc'),
                  "param_name" => "order",
                  "value" => array(
				  					__('DESC','wpmegapack_vc')  => 'DESC',
				  					__('ASC','wpmegapack_vc') 	=> 'ASC'
									
				   ),
				   "group" => "Query"				   			   
				),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Order By", 'wpmegapack_vc'),
                  "param_name" => "orderby",
                  "value" => array(
				  					__('Date','wpmegapack_vc') 				=> 'date',
									__('ID','wpmegapack_vc')  				=> 'ID',
				  					__('Author','wpmegapack_vc') 			=> 'author',
									__('Title','wpmegapack_vc')  			=> 'title',
				  					__('Name','wpmegapack_vc') 				=> 'name',
									__('Modified','wpmegapack_vc')  		=> 'modified',
				  					__('Parent','wpmegapack_vc') 			=> 'parent',
									__('Rand','wpmegapack_vc')  			=> 'rand',
									__('Comments Count','wpmegapack_vc')  	=> 'comment_count',
									__('Views','wpmegapack_vc')				=> 'views',
									__('None','wpmegapack_vc')  			=> 'none',																																													
				   ),
				   "group" => "Query"				   			   
				),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Pagination", 'wpmegapack_vc'),
                  "param_name" => "pagination",
                  "value" => array(
				  					__('No','wpmegapack_vc')  		=> 'no',
				  					__('Yes','wpmegapack_vc') 		=> 'yes'
									
				   ),
				   "group" => "Query"				   			   
				),

			    array(
				  "type" => "textfield", 
				  "class" => "",
				  "heading" => __("Number Posts",'wpmegapack_vc'),
				  "param_name" => "num_posts",
				  "description" => "ex 10",
				  "group" => "Query",
				  "dependency" => array(
							'element' => 'pagination',
							'value' => array( 'no' )
				  ),					  				  					  				  			  				  
			    ),

                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Pagination Type", 'wpmegapack_vc'),
                  "param_name" => "pagination_type",
                  "value" => array(
				  					__('Numeric','wpmegapack_vc') 		=> 'numeric',
									__('Normal','wpmegapack_vc')  		=> 'normal',
				  ),
				  "group" => "Query",
				  "dependency" => array(
							'element' => 'pagination',
							'value' => array( 'yes' )
				  ),				   				   			   
				),

			    array(
				  "type" => "textfield", 
				  "class" => "",
				  "heading" => __("Number Posts For Page",'wpmegapack_vc'),
				  "param_name" => "num_posts_page",
				  "description" => "ex 10",
				  "group" => "Query",
				  "dependency" => array(
							'element' => 'pagination',
							'value' => array( 'yes' )
				  ),					  				  					  				  			  				  
			    ),					
				
				// STYLE
				
                array(
                  	"type" => "dropdown",
                  	"class" => "",
                  	"heading" => __("Layout", 'wpmegapack_vc'),
                  	"param_name" => "layout",
                  	"value" => array(
				  					__('Layout 1','wpmegapack_vc') 		=> 'layout1',
									__('Layout 2','wpmegapack_vc')  	=> 'layout2',
				   	),
				   	"group" => "Style",
				   	"dependency" => array(
							'element' => 'type',
							'value' => array( 'type1', 'type2', 'type3', 'type5', 'type7', 'type8', 'type10')
				   	),				   				   			   
				),				

                array(
                  	"type" => "dropdown",
                  	"class" => "",
                  	"heading" => __("Layout", 'wpmegapack_vc'),
                  	"param_name" => "layout_type4",
                  	"value" => array(
				  					__('Layout 1','wpmegapack_vc') 				=> 'layout1',
									__('Layout 2 (Carousel)','wpmegapack_vc')  	=> 'layout2'
				   	),
				   	"group" => "Style",
				   	"dependency" => array(
							'element' => 'type',
							'value' => array( 'type4' )
				   	),				   				   			   
				),	

                array(
                  	"type" => "dropdown",
                  	"class" => "",
                  	"heading" => __("Layout", 'wpmegapack_vc'),
                  	"param_name" => "layout_type9",
                  	"value" => array(
				  					__('Layout 1','wpmegapack_vc') 		=> 'layout1',
									__('Layout 2','wpmegapack_vc')  	=> 'layout2',
									__('Layout 3','wpmegapack_vc')  	=> 'layout3',
				   	),
				   	"group" => "Style",
				   	"dependency" => array(
							'element' => 'type',
							'value' => array( 'type9' )
				   	),				   				   			   
				),	
				
                array(
                  	"type" => "dropdown",
                  	"class" => "",
                  	"heading" => __("Custom Style", 'wpmegapack_vc'),
                  	"param_name" => "custom_style",
                  	"value" => array(
									__('Off','wpmegapack_vc')  		=> 'off',
				  					__('On','wpmegapack_vc') 		=> 'on',
									
				  	),
				  	"group" => "Style",				   				   			   
				),				
				
				array(
				  	"type" => "colorpicker",
				  	"class" => "",
				  	"heading" => __("Main Color", 'wpmegapack_vc'),
				  	"param_name" => "maincolor",
					"value" => '#e74c3c',
					"group" => "Style",
				  	"dependency" => array(
							'element' => 'custom_style',
							'value' => array( 'on' )
				  	),					
				),				
				
				array(
				  	"type" => "colorpicker",
				  	"class" => "",
				  	"heading" => __("Second Color", 'wpmegapack_vc'),
				  	"param_name" => "secondarycolor",
					"value" => '#FFFFFF',
					"group" => "Style",
				  	"dependency" => array(
							'element' => 'custom_style',
							'value' => array( 'on' )
				  	),					
				),	
				
				array(
				  	"type" => "colorpicker",
				  	"class" => "",
				  	"heading" => __("Third Color", 'wpmegapack_vc'),
				  	"param_name" => "thirdcolor",
					"value" => '#000000',
					"group" => "Style",
				  	"dependency" => array(
							'element' => 'custom_style',
							'value' => array( 'on' )
				  	),					
				),									
				
				
				// CAROUSEL
                 array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Number Item Show", 'wpmegapack_vc'),
                  "param_name" => "item_show",
                  "value" => array(
				  					__('1','wpmegapack_vc') 	=> '1',
									__('2','wpmegapack_vc')  	=> '2',
				  					__('3','wpmegapack_vc') 	=> '3',
									__('4','wpmegapack_vc')  	=> '4',
				  					__('5','wpmegapack_vc') 	=> '5',
									__('6','wpmegapack_vc')  	=> '6',
				  					__('7','wpmegapack_vc') 	=> '7',
									__('8','wpmegapack_vc')  	=> '8',
									__('9','wpmegapack_vc')  	=> '9',																											
				   ),
				    "group" => "Carousel Settings",
				   	"dependency" => array(
							'element' => 'layout_type4',
							'value' => array( 'layout2' )
				   	),					  				   				   			   
				),				
                 array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Item Show for content between 600px tp 900px ", 'wpmegapack_vc'),
                  "param_name" => "item_show_900",
                  "value" => array(
				  					__('1','wpmegapack_vc') 	=> '1',
									__('2','wpmegapack_vc')  	=> '2',
				  					__('3','wpmegapack_vc') 	=> '3',
									__('4','wpmegapack_vc')  	=> '4',
				  					__('5','wpmegapack_vc') 	=> '5',
									__('6','wpmegapack_vc')  	=> '6',
				  					__('7','wpmegapack_vc') 	=> '7',
									__('8','wpmegapack_vc')  	=> '8',
									__('9','wpmegapack_vc')  	=> '9',																											
				   ),
				   "group" => "Carousel Settings",
				   	"dependency" => array(
							'element' => 'layout_type4',
							'value' => array( 'layout2' )
				   	),					  				   				   			   
				),					
                 array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Item Show for content between 0px tp 599px ", 'wpmegapack_vc'),
                  "param_name" => "item_show_600",
                  "value" => array(
				  					__('1','wpmegapack_vc') 	=> '1',
									__('2','wpmegapack_vc')  	=> '2',
				  					__('3','wpmegapack_vc') 	=> '3',
									__('4','wpmegapack_vc')  	=> '4',
				  					__('5','wpmegapack_vc') 	=> '5',
									__('6','wpmegapack_vc')  	=> '6',
				  					__('7','wpmegapack_vc') 	=> '7',
									__('8','wpmegapack_vc')  	=> '8',
									__('9','wpmegapack_vc')  	=> '9',																											
				   ),
				   "group" => "Carousel Settings",
				   	"dependency" => array(
							'element' => 'layout_type4',
							'value' => array( 'layout2' )
				   	),					  				   				   			   
				),

                 array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Lazy Load", 'wpmegapack_vc'),
                  "param_name" => "lazy_load",
                  "value" => array(
				  					__('Off','wpmegapack_vc')  	=> 'false',
				  					__('On','wpmegapack_vc') 	=> 'true' 
																																			
				   ),
				  "group" => "Carousel Settings",
				   	"dependency" => array(
							'element' => 'layout_type4',
							'value' => array( 'layout2' )
				   	),					  				   				   			   
				),
				
				array(
					  "type" => "textfield",
					  "class" => "",
					  "heading" => __("Autoplay",'wpmegapack_vc'),
					  "param_name" => "autoplay",
					  "description" => "ex 2000 or Leave empty for default",					  
					  "group" => "Carousel Settings",
				   		"dependency" => array(
							'element' => 'layout_type4',
							'value' => array( 'layout2' )
				   		),					  					  
				),					
					
                 array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => __("Navigation", 'wpmegapack_vc'),
                  "param_name" => "navigation",
                  "value" => array(
				  					__('Show','wpmegapack_vc') 		=> 'true', 
									__('Hidden','wpmegapack_vc')  	=> 'false'																										
				   ),
				  "group" => "Carousel Settings",
				   	"dependency" => array(
							'element' => 'layout_type4',
							'value' => array( 'layout2' )
				   	),					  				   				   			   
				),								
				
		)		
		) // CLOSE VC MAP
	  );
    }					
}
// Finally initialize code
new wpmegapack_vc_post_display_class();
?>