<?php
/*
File: tab.php
Description: Widget Tab: recent, popular and tags
*/
 
add_action( 'widgets_init', 'WPMP_vc_tab_widgets' );
function WPMP_vc_tab_widgets() {
	register_widget('WPMP_vc_Widget_tab');
}
 
class WPMP_vc_Widget_tab extends WP_Widget {
	function __construct() {
		$widget_ops = array('classname' => 'wpmp-widget wpmegapack_vc wpmp_tab', 'description' => 'Display your posts as a tab!' );
		parent::__construct('tab', 'WPMP VC Tab', $widget_ops);
		$this->alt_option_name = 'widget_mega_entries';
		add_action( 'save_post', array(&$this, 'flush_widget_cache') );
		add_action( 'deleted_post', array(&$this, 'flush_widget_cache') );
		add_action( 'switch_theme', array(&$this, 'flush_widget_cache') );
	}
	function widget($args, $instance) {
		
		$cache = wp_cache_get('widget_tab', 'widget');
		if ( !is_array($cache) )
			$cache = array();
		if ( ! isset( $args['widget_id'] ) )
			$args['widget_id'] = $this->id;
		if ( isset( $cache[ $args['widget_id'] ] ) ) {
			echo $cache[ $args['widget_id'] ];
			return;
		}
		ob_start();
		
		static $instance_widget = 0;
		$instance_widget++;		
		wp_enqueue_style( 'wpmegapack_vc-widget' );
		wp_enqueue_style( 'wpmegapack_vc-fonts' );
		wp_enqueue_style( 'wpmegapack_vc-columns' );

		echo widget_vc_custom_color(get_option( 'wpmp_widget_custom_color' ),
							get_option( 'wpmp_widget_maincolor' ),
							get_option( 'wpmp_widget_secondcolor' ),
							get_option( 'wpmp_widget_thirdcolor' ));
		
		extract($args);
		
		$recent = $instance['recent'];
		$popular = $instance['popular'];
		$tag = $instance['tag'];
		
		if ( empty( $instance['number'] ) || ! $number = absint( $instance['number'] ) ) {
 			$number = 5;
		}
		
		if ( !empty( $instance['orderdir'] ) ) {
 			$orderdir = $instance['orderdir'];
			
		}else{
			
			$orderdir = 'DESC';
			
		}
		
		if ( !empty( $instance['cat_filter'] ) ) {
 			$cat_filter = $instance['cat_filter'];
			
		}else{
			
			$cat_filter = '0';
			
		}
?>
		<script type="text/javascript">
		jQuery(document).ready(function($){
					$('.wpmp_title_recent').on('click', function(event) {
						$('.wpmp-recent').fadeIn();
						$('.wpmp-popular').css("display","none");
						$('.wpmp-tag').css("display","none");
						$('.wpmp_title_recent').addClass('wpmp_tab_active');
						$('.wpmp_title_popular').removeClass('wpmp_tab_active');
						$('.wpmp_title_tag').removeClass('wpmp_tab_active');
					});
					$('.wpmp_title_popular').on('click', function(event) {
						$('.wpmp-recent').css("display","none");
						$('.wpmp-popular').fadeIn();
						$('.wpmp-tag').css("display","none");
						$('.wpmp_title_popular').addClass('wpmp_tab_active');
						$('.wpmp_title_recent').removeClass('wpmp_tab_active');
						$('.wpmp_title_tag').removeClass('wpmp_tab_active');						
					});
					$('.wpmp_title_tag').on('click', function(event) {
						$('.wpmp-recent').css("display","none");
						$('.wpmp-popular').css("display","none");
						$('.wpmp-tag').fadeIn();
						$('.wpmp_title_tag').addClass('wpmp_tab_active');
						$('.wpmp_title_recent').removeClass('wpmp_tab_active');
						$('.wpmp_title_popular').removeClass('wpmp_tab_active');						
					});											
		});
		</script>
        
		<?php echo $before_widget; ?>
		<?php 
		$class_popular = $class_tag = '';
		if(!$recent) { $class_popular = 'style="display:block"'; } 
		if(!$recent && !$popular) { $class_tag = 'style="display:block"'; }
		
		echo $before_title;
		
		if ( $recent ) echo '<span class="wpmp-title-widget wpmp_title_recent wpmp_tab_active">' . $recent . '</span>'; 
		if ( $popular ) echo '<span class="wpmp-title-widget wpmp_title_popular">' . $popular . '</span>'; 
		if ( $tag ) echo '<span class="wpmp-title-widget wpmp_title_tag">' . $tag . '</span>'; 
		
		echo $after_title;
		
		
		?>
        
<?php	
		if ( $recent ) {
				
		$r = new WP_Query( apply_filters( 'widget_posts_args', array( 'posts_per_page' => $number, 'no_found_rows' => true, 'post_status' => 'publish', 'ignore_sticky_posts' => true, 'category__in' => $cat_filter, 'meta_key' => 'wpb_post_views_count', 'orderby' => 'date', 'order' => $orderdir ) ) );
		if ($r->have_posts()) :
?>

		<div class="wpmp-tab-container wpmp-tab-widget-<?php echo $instance_widget; ?> wpmp-recent" style="display:block">
        
		<?php $count = 0; while ($r->have_posts()) : $r->the_post(); ?>
        <style>.wpmp-tab-widget-<?php echo $instance_widget; ?>.wpmp-recent .container_post .wpmp-tab-item-<?php echo $count; ?> { background:url(<?php echo wpmegapack_vc_thumbs_url(get_the_id()); ?>) }</style>
        <div class="box_post">
        	<div class="container_post ad_one_one">
            	<div class="img-post wpmp-tab-item-<?php echo $count; ?> ad_one_third"></div>
            	<div class="box-info ad_two_third">
 					<h4 class="title-post">
        						<a href="<?php the_permalink() ?>" title="<?php echo esc_attr(get_the_title() ? get_the_title() : get_the_ID()); ?>">		
									<?php if ( get_the_title() ) the_title(); else the_ID(); ?>
        						</a>                    
        			</h4>
               		<span class="data"><i class="icon-calendar"></i><?php echo get_the_date(); ?></span>
				</div>
            </div>
        </div>
        
		<?php $count++; endwhile; wp_reset_postdata();  ?>
		</div>
		   
<?php endif; } // #RECENT

		if ( $popular ) {

		$r = new WP_Query( apply_filters( 'widget_posts_args', array( 'posts_per_page' => $number, 'no_found_rows' => true, 'post_status' => 'publish', 'ignore_sticky_posts' => true, 'category__in' => $cat_filter, 'meta_key' => 'wpb_post_views_count', 'orderby' => 'meta_value_num', 'order' => $orderdir ) ) );
		if ($r->have_posts()) :           
?>           
           
		<div class="wpmp-tab-container wpmp-tab-widget-<?php echo $instance_widget; ?> wpmp-popular" <?php echo $class_popular; ?>>
        
		<?php $count = 0; while ($r->have_posts()) : $r->the_post(); ?>
        <style>.wpmp-tab-widget-<?php echo $instance_widget; ?>.wpmp-popular .container_post .wpmp-tab-item-<?php echo $count; ?> { background:url(<?php echo wpmegapack_vc_thumbs_url(get_the_id()); ?>) }</style>
        <div class="box_post">
        	<div class="container_post ad_one_one">
            	<div class="img-post wpmp-tab-item-<?php echo $count; ?> ad_one_third"></div>
            	<div class="box-info ad_two_third">
 					<h4 class="title-post">
        						<a href="<?php the_permalink() ?>" title="<?php echo esc_attr(get_the_title() ? get_the_title() : get_the_ID()); ?>">		
									<?php if ( get_the_title() ) the_title(); else the_ID(); ?>
        						</a>                    
        			</h4>
               		<span class="data"><i class="icon-calendar"></i><?php echo get_the_date(); ?></span>
				</div>
            </div>
        </div>
        
		<?php $count++; endwhile; wp_reset_postdata(); ?>
		</div>
        <?php endif; 
		
		} // #POPULAR
		
		if ( $tag ) {
			
		?>
      	<div class="wpmp-tab-container wpmp-tab-widget-<?php echo $instance_widget; ?> wpmp-tag box_tag" <?php echo $class_tag; ?>>
        
        	<?php 
			$tags = get_tags();
			foreach ( $tags as $tag ) {
				$tag_link = get_tag_link( $tag->term_id );
				
				echo '<div class="content_tag"><a href="'.$tag_link.'" title="'.$tag->name.'" Tag" class="'.$tag->slug.'">'.$tag->name.'</a></div>';
			}	?>
        
        </div>
		
        <?php } // #TAG ?>
		<?php echo $after_widget; ?>
    
<?php	
		$cache[$args['widget_id']] = ob_get_flush();
		wp_cache_set('widget_tab', $cache, 'widget');
	}
	function update( $new_instance, $old_instance ) {
		$instance = $old_instance;
		$instance['recent'] = strip_tags($new_instance['recent']);
		$instance['popular'] = strip_tags($new_instance['popular']);
		$instance['tag'] = strip_tags($new_instance['tag']);
		
		
		$instance['number'] = (int) $new_instance['number'];
		
		$instance['cat_filter'] = $new_instance['cat_filter'];
		
		$instance['orderby'] = $new_instance['orderby'];
		
		$instance['orderdir'] = $new_instance['orderdir'];
		$this->flush_widget_cache();
		$alloptions = wp_cache_get( 'alloptions', 'options' );
		if ( isset($alloptions['widget_mega_entries']) )
			delete_option('widget_mega_entries');
		return $instance;
	}
	function flush_widget_cache() {
		wp_cache_delete('widget_tab', 'widget');
	}
	function form( $instance ) {
		$recent = isset($instance['recent']) ? esc_attr($instance['recent']) : '';
		$popular = isset($instance['popular']) ? esc_attr($instance['popular']) : '';
		$tag = isset($instance['tag']) ? esc_attr($instance['tag']) : '';
		$number = isset($instance['number']) ? absint($instance['number']) : 5;
		
		$cat_filter = isset($instance['cat_filter']) ? $instance['cat_filter'] : '0';
		
		$orderby = isset($instance['orderby']) ? $instance['orderby'] : 'none';
		
		$orderdir = isset($instance['orderdir']) ? $instance['orderdir'] : 'DESC';
?>		<h2><?php echo __('TAB NAME','wpmegapack_vc'); ?></h2>
		<p><label for="<?php echo $this->get_field_id('recent'); ?>"><?php echo __('Recent tab:','wpmegapack_vc'); ?><br><span style="padding-bottom:5px;display:block"><small>- <?php echo __('Leave empty for disable recent tab','wpmegapack_vc'); ?></small></span></label>
		<input class="widefat" id="<?php echo $this->get_field_id('recent'); ?>" name="<?php echo $this->get_field_name('recent'); ?>" type="text" value="<?php echo $recent; ?>" /></p>
		
		<p><label for="<?php echo $this->get_field_id('popular'); ?>"><?php echo __('Popular tab:','wpmegapack_vc'); ?><br><span style="padding-bottom:5px;display:block"><small>- <?php echo __('Leave empty for disable popular tab','wpmegapack_vc'); ?></small></span></label>
		<input class="widefat" id="<?php echo $this->get_field_id('popular'); ?>" name="<?php echo $this->get_field_name('popular'); ?>" type="text" value="<?php echo $popular; ?>" /></p>

		<p><label for="<?php echo $this->get_field_id('tag'); ?>"><?php echo __('Tags tab:','wpmegapack_vc'); ?><br><span style="padding-bottom:5px;display:block"><small>- <?php echo __('Leave empty for disable tags tab','wpmegapack_vc'); ?></small></span></label>
		<input class="widefat" id="<?php echo $this->get_field_id('tag'); ?>" name="<?php echo $this->get_field_name('tag'); ?>" type="text" value="<?php echo $tag; ?>" /></p>
        
        <h2 style="margin-top:30px"><?php echo __('TAB OPTIONS','wpmegapack_vc'); ?></h2>
        
        <p><label for="<?php echo $this->get_field_id('number'); ?>"><?php echo 'Number of posts to show:'; ?></label>
		<input id="<?php echo $this->get_field_id('number'); ?>" name="<?php echo $this->get_field_name('number'); ?>" type="text" value="<?php echo $number; ?>" size="3" /></p>
           
        <p><label for="<?php echo $this->get_field_id('cat_filter'); ?>"><?php echo 'Filter posts by category:'; ?></label>
       
        <?php $categories = get_categories(array('orderby' => 'name','order' => 'ASC')); ?>
        
        <select multiple="multiple" id="<?php echo $this->get_field_id( 'cat_filter' ); ?>" name="<?php echo $this->get_field_name( 'cat_filter' ).'[]'; ?>" class="widefat">
        <?php foreach ($categories as $category) {  ?>
        <?php echo $cat_filter;?>
        <option <?php if ( $cat_filter && in_array($category->term_id, $cat_filter) ){echo 'selected="selected"';} ?> value="<?php echo $category->term_id; ?>"><?php echo $category->name; ?></option>
		<?php } ?>
		</select>
      
        
        </p>
        
        <p><label for="<?php echo $this->get_field_id('orderdir'); ?>"><?php echo 'Order direction:'; ?></label>
		<select id="<?php echo $this->get_field_id( 'orderdir' ); ?>" name="<?php echo $this->get_field_name( 'orderdir' ); ?>" class="widefat">
            <option <?php if ($orderdir == 'ASC' ){echo 'selected="selected"';} ?> value="ASC">Ascending order </option>
            <option <?php if ($orderdir == 'DESC' ){echo 'selected="selected"';} ?> value="DESC">Descending order</option>
        </select>
        </p>
<?php
	}
}
?>